Subject: Re: [ofa-general] NetEffect, iw_nes and kernel warning

From: Stephen Hemminger <[email-masked]>
Date: Fri, 30 Jan 2009 08:25:23 -0800

On Fri, 30 Jan 2009 17:57:21 +1100
Herbert Xu <[email-masked]> wrote:

> Roland Dreier <[email-masked]> wrote:
> > 
> > OK, thanks... what confused me is that several other drivers also do
> > skb_linearize() in their hard_start_xmit method... eg bnx2x,
> > via-velocity, mv643xx_eth.  So there are several other lurking bugs to
> > deal with here I guess.
> 
> I don't know about the rest but bnx2x is certainly OK since it
> only does so with IRQ enabled.  It is legal to call skb_linearize
> as long as you're sure that IRQs are enabled, which is always the
> case for hard_start_xmit upon entry.
> 
> So the only time you can't call it in hard_start_xmit is if you've
> just disabled IRQs yourself.

Or netconsole.
netconsole calls start_xmit from IRQ 
but it is safe since netconsole doesn't send fragmented skb's